=== libraries/Win32/doc/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

XML_DOC = HSWin32

include $(TOP)/mk/target.mk
