=== debian/changelog ===
ghc (8.8.4-2) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Correctly set 'haddock-interfaces' for base libraries (Closes: #968446)
  * Remove files generated by postinst script (Closes: #909922)
  * Add myself as an uploader

  [ Gianfranco Costamagna ]
  * Lower parallel builds to 2 on Ubuntu armhf, to speed up build process.

  [ Adrian Bunk ]
  * Update to llvm-11. (Closes: #974794)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Dec 2020 23:15:42 +0100

ghc (8.8.4-1) unstable; urgency=medium

  * New upstream release
  * Fix gen_contents_index to use ghc-pkg to parse the package database
    (Closes: #966069)
  * Use locally-installed MathJax.js when generating library docs
    (Closes: #890627)
  * Patch Haddock to remove hard-coded googleapis font URL (Closes: #963690)
  * Backport upstream patch to fix FFI on unregisterised big endian machines

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Tue, 11 Aug 2020 17:12:43 +0300

ghc (8.8.3-3) unstable; urgency=medium

  * Reupload due to bad debian/rules merge

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 31 Jul 2020 17:48:26 +0200

ghc (8.8.3-2) unstable; urgency=medium

  * Cherry-pick Ubuntu patches
  * Also limit parallel building to 2 on arm64, because Ubuntu fails
    with ENOMEM with parallel=4
  * Fix ByteOrder on s390x.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jul 2020 16:34:22 +0200
